Package com.google.gwt.user.cellview.client

## Class CellBrowser.BrowserCellList<T>

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.google.gwt.user.client.ui.Composite
      - - com.google.gwt.user.cellview.client.AbstractHasData<T>
        - - com.google.gwt.user.cellview.client.CellList<T>
          - - com.google.gwt.user.cellview.client.CellBrowser.BrowserCellList<T>

- Type Parameters:
    `T` - the data type of list items
  All Implemented Interfaces:
    `HasAttachHandlers`, `HasHandlers`, `HasKeyboardPagingPolicy`, `HasKeyboardSelectionPolicy`, `EventListener`, `Focusable`, `HasVisibility`, `IsRenderable`, `IsWidget`, `HasCellPreviewHandlers<T>`, `HasData<T>`, `HasKeyProvider<T>`, `HasRows`
  Enclosing class:
    CellBrowser

      class CellBrowser.BrowserCellList<T>
      extends CellList<T>

  A custom version of cell list used by the browser. Visible for testing.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.cellview.client.CellList

      `CellList.Resources, CellList.Style, CellList.Template`

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.cellview.client.AbstractHasData

      `AbstractHasData.DefaultKeyboardSelectionHandler<T>, AbstractHasData.RedrawEvent`

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

    - ### Nested classes/interfaces inherited from interface com.google.gwt.user.cellview.client.HasKeyboardPagingPolicy

      `HasKeyboardPagingPolicy.KeyboardPagingPolicy`

    - ### Nested classes/interfaces inherited from interface com.google.gwt.user.cellview.client.HasKeyboardSelectionPolicy

      `HasKeyboardSelectionPolicy.KeyboardSelectionPolicy`

  - ### Field Summary

    - ### Fields inherited from class com.google.gwt.user.cellview.client.AbstractHasData

      `isFocused`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BrowserCellList​(Cell<T> cell, int level, ProvidesKey<T> keyProvider)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `deselectValue()` |
    `protected Element` | `getCellParent​(Element item)` | Get the parent element that wraps the cell from the list item.
    `protected boolean` | `isKeyboardNavigationSuppressed()` | Check if keyboard navigation is being suppressed, such as when the user is editing a cell.
    `protected void` | `onBrowserEvent2​(Event event)` | Called after `AbstractHasData.onBrowserEvent(Event)` completes.
    `protected void` | `renderRowValues​(SafeHtmlBuilder sb, java.util.List<T> values, int start, SelectionModel<? super T> selectionModel)` | Render all row values into the specified `SafeHtmlBuilder`.
    `protected void` | `setKeyboardSelected​(int index, boolean selected, boolean stealFocus)` | Update an element to reflect its keyboard selected state.
    `protected void` | `setSelectedValue​(T value)` | Set the selected value in this list.

    - ### Methods inherited from class com.google.gwt.user.cellview.client.CellList

      `dependsOnSelection, doAttachChildren, doDetachChildren, fireEventToCell, getCell, getChildContainer, getEmptyListMessage, getEmptyListWidget, getKeyboardSelectedElement, getLoadingIndicator, getRowElement, onLoadingStateChanged, resetFocusOnCell, setEmptyListMessage, setEmptyListWidget, setLoadingIndicator, setSelected, setValueUpdater`

    - ### Methods inherited from class com.google.gwt.user.cellview.client.AbstractHasData

      `addCellPreviewHandler, addLoadingStateChangeHandler, addRangeChangeHandler, addRedrawHandler, addRowCountChangeHandler, addValueChangeHandler, adopt, cellConsumesEventType, checkRowBounds, convertToElements, convertToElements, doAttach, doDetach, getAccessKey, getChildElement, getDisplayedItem, getDisplayedItems, getKeyboardPagingPolicy, getKeyboardSelectedRow, getKeyboardSelectionPolicy, getKeyProvider, getPageSize, getPageStart, getPresenter, getRowContainer, getRowCount, getSelectionModel, getTabIndex, getValueKey, getVisibleItem, getVisibleItemCount, getVisibleItems, getVisibleRange, isRowCountExact, isRowWithinBounds, onBlur, onBrowserEvent, onFocus, onUnload, redraw, redrawRow, replaceAllChildren, replaceAllChildren, replaceChildren, replaceChildren, setAccessKey, setFocus, setFocusable, setKeyboardPagingPolicy, setKeyboardSelectedRow, setKeyboardSelectedRow, setKeyboardSelectionHandler, setKeyboardSelectionPolicy, setPageSize, setPageStart, setRowCount, setRowCount, setRowData, setRowData, setSelectionModel, setSelectionModel, setTabIndex, setVisibleRange, setVisibleRange, setVisibleRangeAndClearData, showOrHide`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Composite

      `claimElement, getWidget, initializeClaimedElement, initWidget, isAttached, onAttach, onDetach, render, render, resolvePotentialElement, setWidget`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, fireEvent, getHandlerCount, getLayoutData, getParent, isOrWasAttached, onLoad, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getOffsetHeight, getOffsetWidth, getStyleElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, getTitle, isVisible, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, setElement, setElement, setHeight, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setTitle, setVisible, setVisible, setWidth, sinkBitlessEvent, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### BrowserCellList

          public BrowserCellList​(Cell<T> cell,
                                 int level,
                                 ProvidesKey<T> keyProvider)

  - ### Method Detail

    - #### deselectValue

          protected void deselectValue()

    - #### getCellParent

          protected Element getCellParent​(Element item)

      Description copied from class: `CellList`
      Get the parent element that wraps the cell from the list item. Override this method if you add structure to the element.
      Overrides:
        `getCellParent` in class `CellList<T>`
      Parameters:
        `item` - the row element that wraps the list item
      Returns:
        the parent element of the cell

    - #### isKeyboardNavigationSuppressed

          protected boolean isKeyboardNavigationSuppressed()

      Description copied from class: `AbstractHasData`
      Check if keyboard navigation is being suppressed, such as when the user is editing a cell.
      Overrides:
        `isKeyboardNavigationSuppressed` in class `CellList<T>`
      Returns:
        true if suppressed, false if not

    - #### onBrowserEvent2

          protected void onBrowserEvent2​(Event event)

      Description copied from class: `AbstractHasData`
      Called after `AbstractHasData.onBrowserEvent(Event)` completes.
      Overrides:
        `onBrowserEvent2` in class `CellList<T>`
      Parameters:
        `event` - the event that was fired

    - #### renderRowValues

          protected void renderRowValues​(SafeHtmlBuilder sb,
                                         java.util.List<T> values,
                                         int start,
                                         SelectionModel<? super T> selectionModel)

      Description copied from class: `AbstractHasData`
      Render all row values into the specified `SafeHtmlBuilder`.

      Subclasses can optionally throw an `UnsupportedOperationException` if they prefer to render the rows in `AbstractHasData.replaceAllChildren(List, SafeHtml)` and `AbstractHasData.replaceChildren(List, int, SafeHtml)`. In this case, the `SafeHtml` argument will be null. Though a bit hacky, this is designed to supported legacy widgets that use `SafeHtmlBuilder`, and newer widgets that use other builders, such as the ElementBuilder API.

      Overrides:
        `renderRowValues` in class `CellList<T>`
      Parameters:
        `sb` - the `SafeHtmlBuilder` to render into
        `values` - the row values
        `start` - the absolute start index of the values
        `selectionModel` - the `SelectionModel`

    - #### setKeyboardSelected

          protected void setKeyboardSelected​(int index,
                                             boolean selected,
                                             boolean stealFocus)

      Description copied from class: `AbstractHasData`
      Update an element to reflect its keyboard selected state.
      Overrides:
        `setKeyboardSelected` in class `CellList<T>`
      Parameters:
        `index` - the index of the element
        `selected` - true if selected, false if not
        `stealFocus` - true if the row should steal focus, false if not

    - #### setSelectedValue

          protected void setSelectedValue​(T value)

      Set the selected value in this list. If there is already a selected value, the old value will be deselected.
      Parameters:
        `value` - the selected value